import { ChangeDetectorRef, InjectionToken, OnInit, QueryList, TemplateRef, ViewContainerRef } from '@angular/core';
import { MatFormField, MatFormFieldControl } from '@angular/material/form-field';
import { ErrorMessages } from './error-meassages';
import * as i0 from "@angular/core";
export declare const NGX_MAT_ERROR_DEFAULT_OPTIONS: InjectionToken<ErrorMessages>;
export interface ErrorOutletContext<T> {
    $implicit?: T;
}
export declare class NgxMatErrorDef implements OnInit {
    template: TemplateRef<any>;
    ngxMatErrorDefFor: string;
    constructor(template: TemplateRef<any>);
    ngOnInit(): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatErrorDef, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxMatErrorDef, "[ngxMatErrorDef]", never, { "ngxMatErrorDefFor": { "alias": "ngxMatErrorDefFor"; "required": false; }; }, {}, never, never, true, never>;
}
export declare class NgxMatErrorOutlet {
    readonly viewContainer: ViewContainerRef;
    constructor(viewContainer: ViewContainerRef);
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatErrorOutlet, never>;
    static ɵdir: i0.ɵɵDirectiveDeclaration<NgxMatErrorOutlet, "[ngxMatErrorOutlet]", never, {}, {}, never, never, true, never>;
}
export declare class NgxMatErrors<T> {
    private readonly cdRef;
    private readonly matFormField;
    private readonly messages;
    private readonly messageKeys;
    control?: MatFormFieldControl<any> | '' | null;
    readonly errorOutlet: NgxMatErrorOutlet;
    readonly customErrorMessages: QueryList<NgxMatErrorDef>;
    constructor(cdRef: ChangeDetectorRef, matFormField: MatFormField);
    readonly error$: import("rxjs").Observable<string>;
    private initError;
    private _populateErrorOutlet;
    private _getCustomErrorMessage;
    static ɵfac: i0.ɵɵFactoryDeclaration<NgxMatErrors<any>, [null, { optional: true; }]>;
    static ɵcmp: i0.ɵɵComponentDeclaration<NgxMatErrors<any>, "ngx-mat-errors, [ngx-mat-errors]", never, { "control": { "alias": "ngx-mat-errors"; "required": false; }; }, {}, ["customErrorMessages"], never, true, never>;
}
